#
# Conditional build:
%bcond_without	prof	# profiling library
#
%define		pkgname	utf8-string
Summary:	Support for reading and writing UTF8 Strings
Name:		ghc-%{pkgname}
Version:	1.0.1.1
Release:	3%{?tld}
License:	BSD
Group:		Development/Languages
Source0:	http://hackage.haskell.org/packages/archive/%{pkgname}/%{version}/%{pkgname}-%{version}.tar.gz
# Source0-md5:	fe24e26bd4b09731af66ef27b18b5177
Patch0:		base-dep.patch
URL:		http://hackage.haskell.org/package/utf8-string/
BuildRequires:	ghc >= 6.12.3
%if %{with prof}
BuildRequires:	ghc-prof
%endif
BuildRequires:	rpmbuild(macros) >= 1.608
%requires_eq	ghc
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

# debuginfo is not useful for ghc
%define		_enable_debug_packages	0

%description
A UTF8 layer for IO and Strings. The utf8-string package provides
operations for encoding UTF8 strings to Word8 lists and back, and for
reading and writing UTF8 without truncation.

%package prof
Summary:	Profiling %{pkgname} library for GHC
Summary(pl.UTF-8):	Biblioteka profilująca %{pkgname} dla GHC
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}

%description prof
Profiling %{pkgname} library for GHC.  Should be installed when
GHC's profiling subsystem is needed.

%description prof -l pl.UTF-8
Biblioteka profilująca %{pkgname} dla GHC. Powinna być zainstalowana
kiedy potrzebujemy systemu profilującego z GHC.

%package doc
Summary:	HTML documentation for %{pkgname}
Summary(pl.UTF-8):	Dokumentacja w formacie HTML dla %{pkgname}
Group:		Documentation

%description doc
HTML documentation for %{pkgname}.

%description doc -l pl.UTF-8
Dokumentacja w formacie HTML dla %{pkgname}.

%prep
%setup -q -n %{pkgname}-%{version}
%patch0 -p1

%build
runhaskell Setup.lhs configure -v2 \
	%{?with_prof:--enable-library-profiling} \
	--prefix=%{_prefix} \
	--libdir=%{_libdir} \
	--libexecdir=%{_libexecdir} \
	--docdir=%{_docdir}/%{name}-%{version}

runhaskell Setup.lhs build
runhaskell Setup.lhs haddock --executables

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT%{_libdir}/%{ghcdir}/package.conf.d

runhaskell Setup.lhs copy --destdir=$RPM_BUILD_ROOT

# work around automatic haddock docs installation
%{__rm} -rf %{name}-%{version}-doc
cp -a $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/html %{name}-%{version}-doc
%{__rm} -r $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

runhaskell Setup.lhs register \
	--gen-pkg-config=$RPM_BUILD_ROOT/%{_libdir}/%{ghcdir}/package.conf.d/%{pkgname}.conf

%clean
rm -rf $RPM_BUILD_ROOT

%post
%ghc_pkg_recache

%postun
%ghc_pkg_recache

%files
%defattr(644,root,root,755)
%{_libdir}/%{ghcdir}/package.conf.d/%{pkgname}.conf
%dir %{_libdir}/%{ghcdir}/%{pkgname}-%{version}
%{_libdir}/%{ghcdir}/%{pkgname}-%{version}/*.so
%{_libdir}/%{ghcdir}/%{pkgname}-%{version}/*.a
%exclude %{_libdir}/%{ghcdir}/%{pkgname}-%{version}/*_p.a

%dir %{_libdir}/%{ghcdir}/%{pkgname}-%{version}/Codec
%dir %{_libdir}/%{ghcdir}/%{pkgname}-%{version}/Codec/Binary
%dir %{_libdir}/%{ghcdir}/%{pkgname}-%{version}/Codec/Binary/UTF8
%{_libdir}/%{ghcdir}/%{pkgname}-%{version}/Codec/Binary/UTF8/*.hi
%{_libdir}/%{ghcdir}/%{pkgname}-%{version}/Codec/Binary/UTF8/*.dyn_hi
%dir %{_libdir}/%{ghcdir}/%{pkgname}-%{version}/Data
%dir %{_libdir}/%{ghcdir}/%{pkgname}-%{version}/Data/ByteString
%{_libdir}/%{ghcdir}/%{pkgname}-%{version}/Data/ByteString/*.hi
%{_libdir}/%{ghcdir}/%{pkgname}-%{version}/Data/ByteString/*.dyn_hi
%dir %{_libdir}/%{ghcdir}/%{pkgname}-%{version}/Data/ByteString/Lazy
%{_libdir}/%{ghcdir}/%{pkgname}-%{version}/Data/ByteString/Lazy/*.hi
%{_libdir}/%{ghcdir}/%{pkgname}-%{version}/Data/ByteString/Lazy/*.dyn_hi
%dir %{_libdir}/%{ghcdir}/%{pkgname}-%{version}/Data/String
%{_libdir}/%{ghcdir}/%{pkgname}-%{version}/Data/String/*.hi
%{_libdir}/%{ghcdir}/%{pkgname}-%{version}/Data/String/*.dyn_hi

%if %{with prof}
%files prof
%defattr(644,root,root,755)
%{_libdir}/%{ghcdir}/%{pkgname}-%{version}/*_p.a
%{_libdir}/%{ghcdir}/%{pkgname}-%{version}/Codec/Binary/UTF8/*.p_hi
%{_libdir}/%{ghcdir}/%{pkgname}-%{version}/Data/ByteString/*.p_hi
%{_libdir}/%{ghcdir}/%{pkgname}-%{version}/Data/ByteString/Lazy/*.p_hi
%{_libdir}/%{ghcdir}/%{pkgname}-%{version}/Data/String/*.p_hi
%endif

%files doc
%defattr(644,root,root,755)
%doc %{name}-%{version}-doc/*
%changelog
* Fri Jul 21 2023 TLD Linux <feedback@tld-linux.org>
- For complete changelog see: http://git.tld-linux.org/?p=packages/ghc-utf8-string.git;a=log;h=master

* Sat Mar 19 2022 Jan Rękorajski <baggins@pld-linux.org> 9327669
- rebuild with ghc 8.10.7

* Sat May 30 2020 Jan Rękorajski <baggins@pld-linux.org> 75bc627
- rel 2, added prof package

* Sat May 23 2020 Jan Rękorajski <baggins@pld-linux.org> 16cbd83
- actually updated to 1.0.1.1

* Sat May 23 2020 Jan Rękorajski <baggins@pld-linux.org> df20771
- rel 2, rebuild with ghc 8.10.1

* Fri May 31 2013 Jan Rękorajski <baggins@pld-linux.org> ce9f669
- remove entire docdir

* Fri May 31 2013 Jan Rękorajski <baggins@pld-linux.org> 7b98549
- fix doc install
- rel 3

* Sun Oct 02 2011 Jacek Konieczny <jajcus@pld-linux.org> 5be696d
- removed changelog entries from template

* Sun Oct 02 2011 Jacek Konieczny <jajcus@pld-linux.org> 5b1b2aa
- new package

* Tue Sep 27 2011 Jan Rękorajski <baggins@pld-linux.org> 0ce6d23
- rel 2
- use runhaskell to exec Setup.lhs

* Tue Sep 27 2011 Jan Rękorajski <baggins@pld-linux.org> 6eca526
- fix md5

* Tue Sep 27 2011 Jan Rękorajski <baggins@pld-linux.org> f624d79
- 0.3.7

* Mon Feb 28 2011 Elan Ruusamäe <glen@pld-linux.org> b65391b
- update packaging, %requires_eq dep on ghc

* Thu Feb 24 2011 Elan Ruusamäe <glen@pld-linux.org> 982f852
- release 5

* Thu Feb 24 2011 Elan Ruusamäe <glen@pld-linux.org> 8d020ae
- use %ghcdir moved to common macros

* Thu Feb 24 2011 Elan Ruusamäe <glen@pld-linux.org> 916c4eb
- use %ghc_pkg_recache macro; make url copyable

* Sat Aug 28 2010 Jan Rękorajski <baggins@pld-linux.org> 09a6071
- release 3

* Sat Aug 28 2010 Jan Rękorajski <baggins@pld-linux.org> 5cccf93
- requires_releq due to very unique ids in packages built with ghc 6.12+

* Fri Aug 27 2010 Jan Rękorajski <baggins@pld-linux.org> ffe1379
- rel 2

* Fri Aug 27 2010 Jan Rękorajski <baggins@pld-linux.org> 431dcf8
- updated packaging to new template (ghc 6.12.3+)

* Sat Apr 10 2010 Jan Rękorajski <baggins@pld-linux.org> 013d09c
- removed changelog entries from template

